#!/usr/bin/env python
# ------------------------------------------------------------------------------------
# fw setup
# version 1
# used python 2.7.10 and pyserial2.7
# ------------------------------------------------------------------------------------
# TEST SETTINGS ...
COMPORT = 'COM12'
COMPORT_TIMEOUT = 1			# in seconds
COMPORT_SPEED = 57600		# in baud
# ------------------------------------------------------------------------------------
# should print "2019-11-04_12:02:55: Ch1: 17491, Ch2: 16496, Ch3: 17509, Ch4: 16558"
# ------------------------------------------------------------------------------------

import time
import serial
from time import gmtime, strftime
		
def get_last_edge(ser):
	rc=""
	ser.write("?73\r\n")
	rc =ser.readline()
	rc+=ser.readline()
	#print "*rc: ",rc
	rc1=rc.split('\n')
	#print "*rc1: ",rc1
	rc2=rc1[0].split(' ')
	#print "*rc2: ",rc2
	rc3=rc2[1].replace('\r','')
	#print "*rc3: ",rc3
	return rc3

def enable_all_channels(ser):
	rc=""
	try:
		s=":10 FF\r\n"
		#print s
		ser.write(s)
		rc =ser.readline()
		rc+=ser.readline()
		return "*activated channel 0x"+ch+": "+rc
	except:
		return "no device. ",rc

def disable_all_channels(ser):
	rc=""
	try:
		s=":10 0\r\n"
		#print s
		ser.write(s)
		rc =ser.readline()
		rc+=ser.readline()
		return "*activated channel 0x"+ch+": "+rc
	except:
		return "no device. ",rc

def enable_channel(ser,channel):
	rc=""
	try:
		c=1<<(channel-1)
		ch="{:02x}".format(c)
		s=":10 "+str(ch)+"\r\n"
		#print s
		ser.write(s)
		rc =ser.readline()
		rc+=ser.readline()
		return "*activated channel 0x"+ch+": "+rc
	except:
		return "no device. ",rc


if __name__ == "__main__":
	ser = serial.Serial(COMPORT, COMPORT_SPEED, timeout=COMPORT_TIMEOUT)
	print "*used com port: ",ser.name
	enable_channel(ser,1)
	while 1:
		e1=int(get_last_edge(ser),16)
		mytime=strftime("%Y-%m-%d_%H:%M:%S", gmtime())
		print(mytime+": Ch1: "+str(e1))
		time.sleep(1)
	enable_all_channels(ser)
	ser.close()
